module Main where
import System.IO 
import Data.Char
main :: IO ()
main =  putStrLn "Hallo Welt!"

readn :: Int -> IO String
readn 0 = return []
readn (n + 1) = getChar >>= q
				where q c = readn n >>= r
							where r cs = return (c:cs)

readn' :: Int -> IO String
readn' 0 = return ""
readn' (n + 1) = do {
					c <- getChar;
					cs <- readn' n;
					return (c:cs)}
					
(>>-) :: IO a -> IO b -> IO b
a >>- b = a >>= const b

(<>) :: (a -> IO b) -> (b -> IO c) -> (a -> IO c)
(a <> b) x = a x >>= b

write :: String -> IO ()
write [] = return ()
write (c:cs) = putChar c >> write cs

write' :: String -> IO ()
write' = foldr (>>) (return ()) . map putChar

palindrome :: IO ()
palindrome = do
				putStr "Enter a string: "
				cs <- getLine
				if palin cs
					then putStrLn "Yes"
					else putStrLn "No"
				
palin :: String -> Bool
palin xs = (ys == reverse ys)
		where ys = map toUpper (filter isLetter xs)
--palin xs = (xs == reverse xs)

--(>>=) :: (Monad m) => m a -> (a -> m b) -> m b

hangman :: IO ()
hangman = do
		putStrLn "Denke dir ein Wort aus:"
		word <- silentReadLn
		putStrLn "Und jetzt raten"
		guess word

silentReadLn :: IO String
silentReadLn = do
				c <- getCh
				if c == '\n'
					then do
						putChar c
						return []
					else do
						putChar '-'
						cs <- silentReadLn
						return (c:cs)

guess :: String -> IO ()
guess word = do
			putStr "rate: "
			cs <- getLine
			if cs == word
				then putStrLn "Jeah, geschafft!"
				else do
					putStrLn (compareWord word cs)
					guess word

compareWord :: String -> String -> String
compareWord word cs = map check word
			where check w = if member' cs w then w else '-'
			
member :: String -> Char -> Bool
member [] _ = False
member (x:xs) y
	| x == y = True
	| otherwise = member xs y
	
member' :: String -> Char -> Bool
member' xs c = foldr ((||) . ((==) c)) False xs


-- Anmerkung: Funktioniert (zumindest unter Windows) nur mit dem GHCi
-- (Bug in WinHugs)
getCh :: IO Char
getCh  = do
		hSetEcho stdin False
		c <- getChar
		hSetEcho stdin True
		return c


